<template>
  <div class="w-full h-full bg-white p-4">
    <p class="font-bold text-lg leading-10 border-b-2">品牌管理</p>
    <el-form class="pt-4" :inline="true" :model="formState">
      <el-form-item label="品牌名称">
        <el-input v-model="formState.brandName" placeholder="品牌名称" clearable />
      </el-form-item>
      <el-form-item label="品牌编码">
        <el-input v-model="formState.brandCode" placeholder="品牌编码" clearable />
      </el-form-item>
      <el-form-item label="品牌描述">
        <el-input v-model="formState.brandRemark" placeholder="品牌描述" clearable />
      </el-form-item>

      <el-form-item>
        <el-button type="default" @click="onReset">重置</el-button>
        <el-button type="primary" @click="onQuery">查询</el-button>
      </el-form-item>
    </el-form>

    <div class="">
      <vxe-toolbar>
        <template #buttons>
          <!-- <vxe-button @click="allAlign = 'left'">居左</vxe-button> -->
          <el-button type="primary" @click="showEdit = true">新增</el-button>
          <el-button type="danger" @click="removeRows">删除</el-button>
        </template>
      </vxe-toolbar>
      <vxe-table ref="xTable" size="small" min-height="460" border :loading="loading" :data="tableData">
        <vxe-column type="checkbox" width="50"></vxe-column>
        <!-- <vxe-column field="brandId" title="id" width="200"></vxe-column> -->
        <vxe-column field="brandName" title="品牌名称" width="200"></vxe-column>
        <vxe-column field="brandCode" title="品牌编码" width="120"></vxe-column>
        <vxe-column field="brandRemark" title="品牌描述" show-overflow></vxe-column>
        <vxe-column field="action" title="操作" width="100">
          <template #default="{ row }">
            <el-button type="primary" text size="small" @click="editRow(row)">修改</el-button>
          </template>
        </vxe-column>
      </vxe-table>

      <vxe-pager
        size="small"
        background
        v-model:current-page="formState.currentPage"
        v-model:page-size="formState.pageSize"
        :total="formState.total"
        @page-change="onQuery"
        :layouts="['PrevPage', 'JumpNumber', 'NextPage', 'Sizes', 'FullJump', 'Total']"
      >
      </vxe-pager>
    </div>

    <vxe-modal v-model="showEdit" title="编辑&保存" destroy-on-close esc-closable @hide="onHide">
      <template #default>
        <el-form ref="formRef" label-width="90px" :model="formEdit" :rules="formRules">
          <el-form-item label="品牌名称" prop="brandName">
            <el-input v-model="formEdit.brandName"></el-input>
          </el-form-item>
          <el-form-item label="品牌编码" prop="brandCode">
            <el-input v-model="formEdit.brandCode"></el-input>
          </el-form-item>
          <el-form-item label="品牌描述" prop="brandRemark">
            <el-input type="textarea" v-model="formEdit.brandRemark"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="onSubmit" :loading="saveLoading">提交</el-button>
            <el-button @click="showEdit = false">取消</el-button>
          </el-form-item>
        </el-form>
      </template>
    </vxe-modal>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, reactive, ref } from 'vue'
import { deleteBrands, getBrandsList, modifyBrand, saveBrand } from '@/api/configure/brand'
import { ElMessage } from 'element-plus'
import type { VxeTableInstance } from 'vxe-table'

const loading = ref(false)
const saveLoading = ref(false)
const showEdit = ref(false)
const formState = reactive({
  brandName: '',
  brandCode: '',
  brandRemark: '',
  currentPage: 1,
  pageSize: 10,
  total: 0
})

const formRef = ref()
const xTable = ref<VxeTableInstance>()
const formRules = reactive({
  brandName: [{ required: true, message: '请输入品牌名称', trigger: 'change' }],
  brandCode: [{ required: true, message: '请输入品牌编码', trigger: 'change' }]
})
const formEdit = reactive({
  brandName: '',
  brandCode: '',
  brandRemark: '',
  brandId: null
})

const tableData = ref([])
const onHide = () => {
  // 重置表单
  Object.assign(formEdit, {
    brandName: '',
    brandCode: '',
    brandRemark: '',
    brandId: null
  })
}

const onReset = () => {}

const editRow = (row) => {
  Object.assign(formEdit, row)
  showEdit.value = true
}

const removeRows = async () => {
  const list = xTable.value?.getCheckboxRecords()
  if (list?.length) {
    const ids = list.map((item) => item.brandId).join(',')
    await deleteBrands(ids)
    ElMessage.success('删除成功！')
    onQuery()
  }
}

// 表单提交
const onSubmit = async () => {
  await formRef.value.validate()
  saveLoading.value = true
  try {
    formEdit.brandId ? await modifyBrand(formEdit) : await saveBrand(formEdit)
    ElMessage.success('操作成功！')
    showEdit.value = false
    onQuery()
  } catch {}
  saveLoading.value = false
}

const onQuery = async () => {
  loading.value = true
  try {
    const { data } = await getBrandsList(formState)
    tableData.value = data.result.records
    formState.total = +data.result.total
  } catch {}
  loading.value = false
}

onMounted(() => {
  onQuery()
})
</script>
<style lang="scss" scoped></style>
